<?php if(!defined('APPLICATION')) die();

// Define the plugin:
$PluginInfo['TinyMCEFour'] = array(
   'Name' => 'TinyMCEFour',
   'Description' => 'Adds the TinyMCE jQuery WYSIWYG Editor 4.0.8 to Discussion,Activity,Comments and Private Message Forms, Works on Vanilla 2.0 and 2.1',
   'Version' => '1.3',
   'Author' => "VrijVlinder",
   'AuthorEmail' => 'contact@vrijvlinder.com',
   'AuthorUrl' => 'http://www.vrijvlinder.com',
   
);

class TinyMCEFourPlugin extends Gdn_Plugin {
	
	private $path;
	
	public function __construct()
	{
		$this->path = Gdn::Request()->Url('plugins/TinyMCEFour');
	}
	
	public function Base_Render_Before($Sender)
	{
		$mode = "full"; // simple/full/medium
		
		$Sender->AddJSFile('plugins/TinyMCEFour/tiny_mce.js');
		$Sender->AddJSFile('plugins/TinyMCEFour/jquery.tinymce.js');
		$Sender->Head->AddString($this->_mode($mode));
	}
	
	private function _mode($mode = "full")
	{
		if ($mode == "full")
		{
			return $this->_full();
		}
		elseif ($mode == "full")
		{
			return $this->_full();
		}
		else
		{
			return $this->_simple();
		}
	}
	
	private function _simple()
	{
		$html = <<<EOF
			<script type="text/javascript">
				$().ready(function() {
					$('#Form_Body,body.Profile #Form_Comment,body.Activity #Form_Comment').tinymce({
						// Location of TinyMCE script
						script_url : '$this->path/tiny_mce.js',

						// General options
						theme : "advanced"
                                               
					});
				});
			</script>
EOF;
		// No WhiteSpace in front of EOF!!
		
		return $html;
	}
	
	private function _full()
	{
		$html = <<<EOF
			<script type="text/javascript">
				$().ready(function() {
					$('#Form_Body,body.Profile #Form_Comment,body.Activity #Form_Comment').tinymce({
						// Location of TinyMCE script
						script_url : '$this->path/tiny_mce.js',
					
						// General options
						theme : "advanced",
                                              
						plugins : "pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,advlist",

						// Theme options
						theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,styleselect,formatselect,fontselect,fontsizeselect",
						theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
						theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,iespell,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
						theme_advanced_buttons4 : "insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,visualchars,nonbreaking,template,pagebreak",
						theme_advanced_toolbar_location : "top",
						theme_advanced_toolbar_align : "left",
						theme_advanced_statusbar_location : "bottom",
						theme_advanced_resizing : true,

						// Example content CSS (should be your site CSS)
						content_css : "css/content.css",

						// Drop lists for link/image/media/template dialogs
						template_external_list_url : "lists/template_list.js",
						external_link_list_url : "lists/link_list.js",
						external_image_list_url : "lists/image_list.js",
						media_external_list_url : "lists/media_list.js",

						// Replace values for the template plugin
						template_replace_values : {
							username : "Some User",
							staffid : "991234"
						}
					});
				});
			</script>
EOF;
		// No WhiteSpace in front of EOF!!

		return $html;		
	}
	
	private function _advanced()
	{
		$html = <<<EOF
			<script type="text/javascript">
				$().ready(function() {
					$('#Form_Body,body.Profile #Form_Comment,body.Activity #Form_Comment').tinymce({
						// Location of TinyMCE script
						script_url : '$this->path/tiny_mce.js',

						// General options
						theme : "advanced",
                                                 
						plugins : "pagebreak,style,layer,table,save,advhr,advimage,advlink,emotions,iespell,inlinepopups,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,advlist",

						// Theme options
						theme_advanced_buttons1 : "save,newdocument,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,styleselect,formatselect,fontselect,fontsizeselect",
						theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code,|,insertdate,inserttime,preview,|,forecolor,backcolor",
						theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,charmap,emotions,iespell,media,advhr,|,print,|,ltr,rtl,|,fullscreen",
						theme_advanced_toolbar_location : "top",
						theme_advanced_toolbar_align : "left",
						theme_advanced_statusbar_location : "bottom",
						theme_advanced_resizing : true,

						// Example content CSS (should be your site CSS)
						content_css : "css/content.css",

						// Drop lists for link/image/media/template dialogs
						template_external_list_url : "lists/template_list.js",
						external_link_list_url : "lists/link_list.js",
						external_image_list_url : "lists/image_list.js",
						media_external_list_url : "lists/media_list.js",

						// Replace values for the template plugin
						template_replace_values : {
							username : "Some User",
							staffid : "991234"
						}					
					});
				});
			</script>
EOF;
		// No WhiteSpace in front of EOF!!

		return $html;		
	}	
	
	public function Setup(){}
}